'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var path = require('path');

var express = require('express');
var opener = require('opener');

var _require = require('chalk');

var bold = _require.bold;


var analyzer = require('./analyzer');

var projectRoot = path.resolve(__dirname, '..');

module.exports = {
  start: start
};

function start(bundleStats, opts) {
  opts = (0, _extends3.default)({
    port: 8888,
    openBrowser: true,
    bundleDir: null
  }, opts);

  var chartData = void 0;
  try {
    chartData = analyzer.getChartData(bundleStats, opts.bundleDir);
  } catch (err) {
    console.error('Could\'t analyze webpack bundle:\n' + err);
    return;
  }

  var app = express();

  app.set('view engine', 'pug');
  app.set('views', projectRoot + '/views');
  app.use(express.static(projectRoot + '/client'));
  app.use('/filesize.js', express.static(require.resolve('filesize')));

  app.use('/', function (req, res) {
    res.render('viewer', {
      chartData: (0, _stringify2.default)(chartData)
    });
  });

  return app.listen(opts.port, function () {
    var url = 'http://localhost:' + opts.port;

    console.log(bold('Webpack Bundle Analyzer') + ' is started at ' + bold(url) + '\n' + ('Use ' + bold('Ctrl+C') + ' to close it'));

    if (opts.openBrowser) {
      opener(url);
    }
  });
}